//   RW Thread
// ==============
// ______
// -Part of the RW Foundations suite of libraries

// Filename: ./include/curator/bumpmaster/post.hpp
// -Declarations of the baseline RW Thread sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::curator::bumpmaster {

//------------------------------------------------------------------------------
/**
 */
class Thread_b : public RW_slave {
 public:
  Thread_b(Hip const& tag, std::string const& handle);  // tag-parm'd ctor

  auto parse_posts(Hip const& tag) -> int;       // guarded; for Master only
  auto crosslink_posts(Hip const& tag) -> bool;  //  "

 private:
  Thread_b() = delete;  // no default ctor
};

//------------------------------------------------------------------------------
/**
 */
class Thread : public Thread_b {
 private:
  Thread() = delete;  // no default ctor
};

}  // namespace rw::curator::bumpmaster

//    --=^=--

// "______"

// rw_curator_lib.v220115
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
