// RW Waifusearch
// ==============
// Fast Imageboard Searching Library
// -Part of the RW Foundations suite of libraries

// Filename: ./include/curator/waifusearch/waifusearch.hpp
// -Declarations of the baseline RW Waifusearch sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::curator::waifusearch {

//------------------------------------------------------------------------------
/**
 */
class Waifusearch_b : public RW {
 public:
  Waifusearch_b();                                    // default ctor
  explicit Waifusearch_b(std::string const& handle);  // tag-parm'd ctor
};

//------------------------------------------------------------------------------
/**
 */
class Waifusearch : public Waifusearch_b {
 public:
  Waifusearch();                                    // default ctor
  explicit Waifusearch(std::string const& handle);  // tag-parm'd ctor

  inline auto curator() const -> Curator& { return curator_; }

 private:
  unique_ptr<Curator_b> _curator_{
      make_unique<Curator_b>("waifusearch_curator")};

  Curator& curator_{reference_to<Curator>(_curator_.get())};
};

}  // namespace rw::curator::waifusearch

//    --=^=--

// "______"

// rw_curator_lib.v220115
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
