//   RW Charger
// ==============
// Power : Distribution, Controllers, Batteries & Charging Library
// -Part of the RW Foundations suite of libraries

// Filename: ./include/electro/power/charger.hpp
// -Declarations of the baseline RW Charger sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::electro::power {

//------------------------------------------------------------------------------
/**
 */
class Charger_b : public RW {
 public:
  Charger_b();                                    // default ctor
  explicit Charger_b(std::string const& handle);  // tag-parm'd ctor
};

//------------------------------------------------------------------------------
/**
 */
class Charger : public Charger_b {
 public:
  Charger();                                    // default ctor
  explicit Charger(std::string const& handle);  // tag-parm'd ctor

  inline auto battery() const -> Battery& { return battery_; }

 private:
  unique_ptr<Battery_b> _battery_{make_unique<Battery_b>("charger_battery")};

  Battery& battery_{reference_to<Battery>(_battery_.get())};
};

}  // namespace rw::electro::power

//    --=^=--

// "Now be careful. If you go for a full charge, it can get up there."

// rw_electro_lib.v220115
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
