// RW Bumpmaster Project
// =====================
// Imageboard downloader + archiver demo project;  SAVE.EVERYTHING.ANON. :^)

// Filename: ./main_bumpmaster.cpp
// -The program's entry point

#include "incls_all.hpp"

void diag_bumpmaster(Bumpmaster const& bump);

//------------------------------------------------------------------------------
/**
 */
int main() try {
  puts("\nSAVE.EVERYTHING.ANON. :^)\n");

  Bumpmaster bump{"bumpmaster"};
  diag_bumpmaster(bump);

  // TEST: TEMP:  pull(),  pull_w_hdr(),  pull_hdr()

  puts("\n\n     --=^=--\n\n");
  //--------
  auto body = bump.dolldrop().pull(bump.t(), "example.com");
  // if (! is_empty(body))
  //   cout << body.rdbuf();

  puts("\n\n     --=^=--\n\n");
  // --------
  auto hdr_A = bump.dolldrop().pull_w_hdr(bump.t(), "example.com");
  if (! is_empty(hdr_A))
    cout << hdr_A.str();

  puts("\n\n     --=^=--\n\n");
  // --------
  auto hdr_B = bump.dolldrop().pull_hdr(bump.t(), "example.com");
  if (! is_empty(hdr_B))
    cout << hdr_B.str();

  puts("\n\n     --=^=--\n\n");
  // --------
  // if (use_stamps)
  //   analyze_callgraph();

  puts("\n...leaving main()\n");

} catch (runtime_error const& e) {
  cerr << "\n  runtime_error '" << e.what() << "' caught in main()\n\n";

} catch (exception const& e) {
  cerr << "\n  exception '" << e.what() << "' caught in main()\n\n";

} catch (...) {
  cerr << "\n  unknown error caught in main()\n\n";
}

//------------------------------------------------------------------------------
/**
 * @param bump
 */
void diag_bumpmaster(Bumpmaster const& bump) {  //

  prt_tag(bump.t(), "bump");
  prt_tag(bump.board().t(), "bump.board()");
  prt_tag(bump.catalog().t(), "bump.catalog()");
  prt_tag(bump.page().t(), "bump.page()");
  prt_tag(bump.post().t(), "bump.post()");
  prt_tag(bump.site().t(), "bump.site()");
  prt_tag(bump.thread().t(), "bump.thread()");
  prt_tag(bump.waifusearch().t(), "bump.waifusearch()");
  //
  prt_tag(bump.dolldrop().t(), "bump.dolldrop()");
}

//    --=^=--

// "Everyone's talking about IT & the Internet, and how advanced it's getting."

// rw_bumpmaster_demo.v220115
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
