//   RW Thread
// ==============
// ______
// -Part of the RW Foundations suite of libraries

// Filename: ./src/curator/bumpmaster/thread.cpp
// -Definitions of the baseline RW Thread sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::curator::bumpmaster {

//------------------------------------------------------------------------------
Thread_b::Thread_b(Hip const& tag, std::string const& handle)
    : RW_slave{{Type::Bumpmaster}, handle} {
  stamp("Thread_b()");

  bind_master(tag);
}

//------------------------------------------------------------------------------
auto Thread_b::parse_posts(const Hip& tag /*, std::vector<Thread> posts*/)
    -> int {
  stamp(tag, "parse_posts()");

  if (tag == master()) {  // function is meant only for slave's Master to use
    // TODO:
    // ...
    // posts.emplace_back(thrd);
    // ...

    // return posts.size();
    return 1;  // TEMP:
  } else
    only_master_can(master(), tag, t(), "Thread_b::parse_posts()");

  //
  return 9'001'42;  // shouldn't reach here
}

//------------------------------------------------------------------------------
auto Thread_b::crosslink_posts(Hip const& tag) -> bool {
  stamp(tag, "crosslink_posts()");

  if (tag == master()) {  // function is meant only for slave's Master to use
    // TODO:
    // ...

    return true;  // TEMP:
  } else
    only_master_can(master(), tag, t(), "Thread_b::crosslink_posts()");

  ///
  return false;  // shouldn't reach here
}

}  // namespace rw::curator::bumpmaster

//    --=^=--

// "______"

// rw_curator_lib.v220115
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
