//    RW Power
// ==============
// Power : Distribution, Controllers, Batteries & Charging Library
// -Part of the RW Foundations suite of libraries

// Filename: ./src/electro/power/power.cpp
// -Definitions of the baseline RW Power library

#include "incls_all.hpp"

namespace rw::electro::power {

//------------------------------------------------------------------------------
Power_b::Power_b() : Power_b{"power_b_obj"} {}

//------------------------------------------------------------------------------
Power_b::Power_b(std::string const& handle) : RW{handle, Type::Power} {
  stamp("Power_b()");
}

//------------------------------------------------------------------------------
Power::Power() : Power{"power_obj"} {}

//------------------------------------------------------------------------------
Power::Power(std::string const& handle) : Power_b{handle} {
  stamp("Power()");
}

}  // namespace rw::electro::power

//    --=^=--

// "Now be careful. If you go for a full charge, it can get up there."

// rw_electro_lib.v220115
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
